'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isUndefined = isUndefined;
exports.checkPayload = checkPayload;
exports.checkUpdate = checkUpdate;
exports.modifier = modifier;

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isUndefined(check) {
  return typeof check == 'undefined';
}

function checkPayload(action) {
  if (isUndefined(action.payload)) throw new Error("Action must contain a payload!");
}

function checkUpdate(action) {
  var payload = action.payload;
  var value = payload.value;
  var fn = payload.fn;


  if (isUndefined(value) && isUndefined(value)) throw new Error("Either 'value' or 'fn' must be present in payload!");

  if (!isUndefined(value) && !isUndefined(fn)) throw new Error("Both 'value' and 'fn' cannot be present in payload!");
}

function modifier(value, fn) {
  return value ? function (val) {
    return _immutable2.default.fromJS(value);
  } : fn;
}